# Calculate the densities for all DM particles using the Voronoi tessellation.
# This is a backup if Revolver fails.

density_output_file=$(density_dir)/densities_voronoi.npy
done_density_file=$(density_dir)/done_calc_dens
lensing_paramsfile=$(pconfdir)/lensing-params.conf

REVOLVER_PATH = $(ilibpydir)/Revolver
LD_LIBRARY_PATH_PYTHON=${REVOLVER_PATH}/python_tools:${LD_LIBRARY_PATH}

.PHONY : calc_densities
calc_densities: $(done_density_file) $(mtexdir)/calc_densities.tex

$(done_density_file): $(density_output_file) $(done_run_simulation_file) $(sim_paramsfile)

$(density_output_file): \
              $(done_run_simulation_file)
	cp -pv $(bashdir)/run-calc-dens $(ibdir)
	cp -pv $(pythondir)/read.py $(ilibpydir)
	cp -pv $(pythondir)/calc_dens.py $(ibdir)
	mkdir -p $(density_dir)
	cd $(density_dir)
	SIM_DIR=$(sim_out_dir) \
	 LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_PYTHON) \
	 finishing_time_step_margin=$(finishing_time_step_margin) \
	 LBOX=$(Lbox) \
	 run-calc-dens
	touch $(done_density_file)

$(mtexdir)/calc_densities.tex:
	printf "%% Automatically produced file.\n" > $@
	printf "\\\\newcommand{\\\\HowWeCalcDensities}{This is how we calculated the densities.}\n\n" >> $@


.PHONY : clean-density-calc
clean-density-calc:
	rm -fv $(density_output_file)
	rm -fv $(done_density_file)
