## A cheap hack to ensure stacking

## Include the initial conditions parameters:
#sim_paramsfile = $(pconfdir)/init-conditions-params.conf
#include reproduce/analysis/make/lensing.mk
#include reproduce/analysis/make/run-simulations.mk
#include reproduce/analysis/make/init-N-body.mk

lensing_paramsfile=$(pconfdir)/lensing-params.conf
stack_res_dir = $(BDIR)/analysis/stacking_res
do_stacking=$(stack_res_dir)/do_stacking
done_stacking_file=$(stack_res_dir)/done-stacking-calculations
example_stacking_output_file=$(stack_res_dir)/mass_deficit_void_cart_gals_0.eps


py_library_files = $(pythondir)/extra_calculations.py \
	$(pythondir)/read.py \
	$(pythondir)/figures.py \
	$(pythondir)/coordinates.py \
	$(pythondir)/lensing_calculations.py

output_eps_files = mass_deficit_void_cart_gals \
	average_mass_def \
	densities_cart_void_gals \
	potential_cart_void_gals \
	real_theta_void_cart_gals \
	average_expansion \
	real_sigma_void_cart_gals \
	img_sigma_void_cart_gals \
	mag_sigma_void_cart_gals \
	theta_deviation_void_cart_gals \
	weak_lensing_gamma_grid_gals \
	average_weak_lensing_gamma

REVOLVER_PATH = $(ilibpydir)/Revolver
LD_LIBRARY_PATH_PYTHON=${REVOLVER_PATH}/python_tools:${LD_LIBRARY_PATH}


#aliases
.PHONY : stacking
stacking: $(done_stacking_file) $(mtexdir)/stacking.tex

.PHONY : stacking.tex
stacking.tex: $(mtexdir)/stacking.tex

$(done_stacking_file): $(example_stacking_output_file)

$(clean-init-conditions):
	rm -f $(example_initcond_output_file) $(init_dir)/mpgrafic-sanity-check \
	  $(done_init_conditions_file)

clean2:
	printf "cleaned simulation\n"

do_lensing_again : lensing
	printf "do lening again...\n"
	touch $(do_stacking)

$(example_stacking_output_file): \
	      $(done_run_simulation_file) \
              $(done_lensing_file)
	cur_dir=$$(pwd)
	if [ "x$(stacking)" = "xYES" ] ; then
	  cp -pv $(py_library_files) $(ilibpydir)
	  cp -pv $(bashdir)/run-stacking $(ibdir)
	  cp -pv $(pythondir)/stacking.py $(ibdir)
#	  cp -pv $(ibdir)/optical_scalar_solver.so $(stack_res_dir)
#	  cp -pv $(ibdir)/gsl_integration.so $(stack_res_dir)
	  if [ ! -d $(stack_res_dir) ] ; then
	    mkdir -p $(stack_res_dir)
	  fi
	  if [ ! -f $(stack_res_dir)/current_nstack.txt ]; then
	    echo 1 > $(stack_res_dir)/current_nstack.txt
	  fi
	  cd $(stack_res_dir)
	  NSTACK=$$(cat $(stack_res_dir)/current_nstack.txt)
	  if [ $${NSTACK} -lt $(N_stack) ] ; then
	    while [[ $${NSTACK} -lt $(N_stack) ]] ; do
	      # This step can only start after lensing at least
	      # ran once. We save the output and increase the
	      # current stack counter already.
	      mv -v $(lensing_dir)/*.npy $(stack_res_dir)
	      NSTACK=$$(( $${NSTACK} + 1 ))
	      printf "\nNSTACK=$${NSTACK}\n"
	      echo $${NSTACK} > current_nstack.txt
	      cd $${cur_dir}
	      printf "\ncur_dir=$${cur_dir}\n"
	      ./project make clean-simulation
	      ./project make clean-init-conditions
	      ./project make clean-lensing-calculations
	      ./project make lensing
	      #$(MAKE) do_stacking
	      #$(MAKE) clean2
	      #$(MAKE) do_lensing_again
	      done
	  fi
	  LBOX=$(Lbox) HUBBLE0=$(Hubble) \
	   OMEGA_M=$(OmegaM) \
	   OMEGA_LAMBDA=$(OmegaL) \
	   MAIN_VOID_REDSHIFT=$(main_void_redshift) \
	   SPHERICAL_CALC=$(spherical_calc) \
	   TEST_WEYL=$(do_test_weyl) \
	   VELOCITY_CENTRE=$(do_velocity_centre) \
	   MASS_DEF=$(do_mass_def) \
	   ISW=$(do_ISW) \
	   DOPPLER_LENSING=$(do_doppler_lensing) \
	   OPTICAL_SCALARS=$(do_solve_scalars) \
	   NSTACK=$${NSTACK} \
	   STACK_DIR=$(stack_res_dir) \
	   N_PIXELS=$(N_pixels) \
	   LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_PYTHON) \
	   DIFF_SOLVER_PATH=$(bsdir)/installed/lib/ \
	   LENSING_DIR=$(lensing_dir) \
	   run-stacking
	  touch $(done_stacking_file)
	  for fig in $(output_eps_files); do
	    cp -pv $${fig}_0.eps $(fig_dir)/$${fig}_stacked.eps
	    done
	fi

$(do_stacking): \
	     clean-simulation \
	     clean-init-conditions
	if [ $(N_stack) -gt 1  && $${NSTACK} -le $(N_stack) ] ; then
	  if [ "x$(stacking)" = "xYES" ] ; then
	    mv -v $(lensing_dir)/*.npy $(stack_res_dir)
	    NSTACK=$$(( $${NSTACK} + 1 ))
	    echo $${NSTACK} > current_nstack.txt
	    touch $(do_stacking)
	  fi
	fi

$(mtexdir)/stacking.tex: $(done_stacking_file)
        # This section produces a file with LaTeX macros for some of
        # the parameters in $(lensing_paramsfile). It presently
        # selects a small hardwired list of parameters rather than all
        # of them. This section will be re-run if $(lensing_paramsfile) is
        # updated.
	printf "%% Automatically produced file.\n\n"
	printf "%% Automatically produced file.\n\n" > $@
	printf "\nThe LaTeX macro file $@ was created.\n\n"
